// https://gpuweb.github.io/gpuweb/wgsl/#keyword-summary
pub const RESERVED: &[&str] = &[
    // Type-defining keywords
    "ARRAY",
    "BOOL",
    "FLOAT32",
    "INT32",
    "MAT2x2",
    "MAT2x3",
    "MAT2x4",
    "MAT3x2",
    "MAT3x3",
    "MAT3x4",
    "MAT4x2",
    "MAT4x3",
    "MAT4x4",
    "POINTER",
    "SAMPLER",
    "SAMPLER_COMPARISON",
    "STRUCT",
    "TEXTURE_1D",
    "TEXTURE_2D",
    "TEXTURE_2D_ARRAY",
    "TEXTURE_3D",
    "TEXTURE_CUBE",
    "TEXTURE_CUBE_ARRAY",
    "TEXTURE_MULTISAMPLED_2D",
    "TEXTURE_STORAGE_1D",
    "TEXTURE_STORAGE_2D",
    "TEXTURE_STORAGE_2D_ARRAY",
    "TEXTURE_STORAGE_3D",
    "TEXTURE_DEPTH_2D",
    "TEXTURE_DEPTH_2D_ARRAY",
    "TEXTURE_DEPTH_CUBE",
    "TEXTURE_DEPTH_CUBE_ARRAY",
    "UINT32",
    "VEC2",
    "VEC3",
    "VEC4",
    // Other keywords
    "BITCAST",
    "BLOCK",
    "BREAK",
    "CASE",
    "CONTINUE",
    "CONTINUING",
    "DEFAULT",
    "DISCARD",
    "ELSE",
    "ELSE_IF",
    "ENABLE",
    "FALLTHROUGH",
    "FALSE",
    "FN",
    "FOR",
    "FUNCTION",
    "IF",
    "LET",
    "LOOP",
    "PRIVATE",
    "RETURN",
    "STORAGE",
    "SWITCH",
    "TRUE",
    "TYPE",
    "UNIFORM",
    "VAR",
    "WORKGROUP",
    // Image format keywords
    "R8UNORM",
    "R8SNORM",
    "R8UINT",
    "R8SINT",
    "R16UINT",
    "R16SINT",
    "R16FLOAT",
    "RG8UNORM",
    "RG8SNORM",
    "RG8UINT",
    "RG8SINT",
    "R32UINT",
    "R32SINT",
    "R32FLOAT",
    "RG16UINT",
    "RG16SINT",
    "RG16FLOAT",
    "RGBA8UNORM",
    "RGBA8UNORM-SRGB",
    "RGBA8SNORM",
    "RGBA8UINT",
    "RGBA8SINT",
    "BGRA8UNORM",
    "BGRA8UNORM-SRGB",
    "RGB10A2UNORM",
    "RG11B10FLOAT",
    "RG32UINT",
    "RG32SINT",
    "RG32FLOAT",
    "RGBA16UINT",
    "RGBA16SINT",
    "RGBA16FLOAT",
    "RGBA32UINT",
    "RGBA32SINT",
    "RGBA32FLOAT",
    // Reserved Keywords
    "asm",
    "bf16",
    "do",
    "enum",
    "f16",
    "f64",
    "i8",
    "i16",
    "i64",
    "const",
    "typedef",
    "u8",
    "u16",
    "u64",
    "unless",
    "using",
    "while",
    "regardless",
    "premerge",
    "handle",
];
