// Copyright 2020 Mathias Bynens. All rights reserved.
// This code is governed by the BSD license found in the LICENSE file.

/*---
author: Mathias Bynens
esid: sec-names-and-keywords
description: |
  Test that Unicode v13.0.0 ID_Start characters are accepted as
  identifier start characters.
info: |
  Generated by https://github.com/mathiasbynens/caniunicode
---*/

var ࢾࢿࣀࣁࣂࣃࣄࣅࣆࣇഄㆻㆼㆽㆾㆿ䶶䶷䶸䶹䶺䶻䶼䶽䶾䶿鿰鿱鿲鿳鿴鿵鿶鿷鿸鿹鿺鿻鿼ꟇꟈꟉꟊꟵꟶꭨꭩ𐺀𐺁𐺂𐺃𐺄𐺅𐺆𐺇𐺈𐺉𐺊𐺋𐺌𐺍𐺎𐺏𐺐𐺑𐺒𐺓𐺔𐺕𐺖𐺗𐺘𐺙𐺚𐺛𐺜𐺝𐺞𐺟𐺠𐺡𐺢𐺣𐺤𐺥𐺦𐺧𐺨𐺩𐺰𐺱𐾰𐾱𐾲𐾳𐾴𐾵𐾶𐾷𐾸𐾹𐾺𐾻𐾼𐾽𐾾𐾿𐿀𐿁𐿂𐿃𐿄𑅇𑑠𑑡𑤀𑤁𑤂𑤃𑤄𑤅𑤆𑤉𑤌𑤍𑤎𑤏𑤐𑤑𑤒𑤓𑤕𑤖𑤘𑤙𑤚𑤛𑤜𑤝𑤞𑤟𑤠𑤡𑤢𑤣𑤤𑤥𑤦𑤧𑤨𑤩𑤪𑤫𑤬𑤭𑤮𑤯𑤿𑥁𑾰𘫳𘫴𘫵𘫶𘫷𘫸𘫹𘫺𘫻𘫼𘫽𘫾𘫿𘬀𘬁𘬂𘬃𘬄𘬅𘬆𘬇𘬈𘬉𘬊𘬋𘬌𘬍𘬎𘬏𘬐𘬑𘬒𘬓𘬔𘬕𘬖𘬗𘬘𘬙𘬚𘬛𘬜𘬝𘬞𘬟𘬠𘬡𘬢𘬣𘬤𘬥𘬦𘬧𘬨𘬩𘬪𘬫𘬬𘬭𘬮𘬯𘬰𘬱𘬲𘬳𘬴𘬵𘬶𘬷𘬸𘬹𘬺𘬻𘬼𘬽𘬾𘬿𘭀𘭁𘭂𘭃𘭄𘭅𘭆𘭇𘭈𘭉𘭊𘭋𘭌𘭍𘭎𘭏𘭐𘭑𘭒𘭓𘭔𘭕𘭖𘭗𘭘𘭙𘭚𘭛𘭜𘭝𘭞𘭟𘭠𘭡𘭢𘭣𘭤𘭥𘭦𘭧𘭨𘭩𘭪𘭫𘭬𘭭𘭮𘭯𘭰𘭱𘭲𘭳𘭴𘭵𘭶𘭷𘭸𘭹𘭺𘭻𘭼𘭽𘭾𘭿𘮀𘮁𘮂𘮃𘮄𘮅𘮆𘮇𘮈𘮉𘮊𘮋𘮌𘮍𘮎𘮏𘮐𘮑𘮒𘮓𘮔𘮕𘮖𘮗𘮘𘮙𘮚𘮛𘮜𘮝𘮞𘮟𘮠𘮡𘮢𘮣𘮤𘮥𘮦𘮧𘮨𘮩𘮪𘮫𘮬𘮭𘮮𘮯𘮰𘮱𘮲𘮳𘮴𘮵𘮶𘮷𘮸𘮹𘮺𘮻𘮼𘮽𘮾𘮿𘯀𘯁𘯂𘯃𘯄𘯅𘯆𘯇𘯈𘯉𘯊𘯋𘯌𘯍𘯎𘯏𘯐𘯑𘯒𘯓𘯔𘯕𘯖𘯗𘯘𘯙𘯚𘯛𘯜𘯝𘯞𘯟𘯠𘯡𘯢𘯣𘯤𘯥𘯦𘯧𘯨𘯩𘯪𘯫𘯬𘯭𘯮𘯯𘯰𘯱𘯲𘯳𘯴𘯵𘯶𘯷𘯸𘯹𘯺𘯻𘯼𘯽𘯾𘯿𘰀𘰁𘰂𘰃𘰄𘰅𘰆𘰇𘰈𘰉𘰊𘰋𘰌𘰍𘰎𘰏𘰐𘰑𘰒𘰓𘰔𘰕𘰖𘰗𘰘𘰙𘰚𘰛𘰜𘰝𘰞𘰟𘰠𘰡𘰢𘰣𘰤𘰥𘰦𘰧𘰨𘰩𘰪𘰫𘰬𘰭𘰮𘰯𘰰𘰱𘰲𘰳𘰴𘰵𘰶𘰷𘰸𘰹𘰺𘰻𘰼𘰽𘰾𘰿𘱀𘱁𘱂𘱃𘱄𘱅𘱆𘱇𘱈𘱉𘱊𘱋𘱌𘱍𘱎𘱏𘱐𘱑𘱒𘱓𘱔𘱕𘱖𘱗𘱘𘱙𘱚𘱛𘱜𘱝𘱞𘱟𘱠𘱡𘱢𘱣𘱤𘱥𘱦𘱧𘱨𘱩𘱪𘱫𘱬𘱭𘱮𘱯𘱰𘱱𘱲𘱳𘱴𘱵𘱶𘱷𘱸𘱹𘱺𘱻𘱼𘱽𘱾𘱿𘲀𘲁𘲂𘲃𘲄𘲅𘲆𘲇𘲈𘲉𘲊𘲋𘲌𘲍𘲎𘲏𘲐𘲑𘲒𘲓𘲔𘲕𘲖𘲗𘲘𘲙𘲚𘲛𘲜𘲝𘲞𘲟𘲠𘲡𘲢𘲣𘲤𘲥𘲦𘲧𘲨𘲩𘲪𘲫𘲬𘲭𘲮𘲯𘲰𘲱𘲲𘲳𘲴𘲵𘲶𘲷𘲸𘲹𘲺𘲻𘲼𘲽𘲾𘲿𘳀𘳁𘳂𘳃𘳄𘳅𘳆𘳇𘳈𘳉𘳊𘳋𘳌𘳍𘳎𘳏𘳐𘳑𘳒𘳓𘳔𘳕𘴀𘴁𘴂𘴃𘴄𘴅𘴆𘴇𘴈𪛗𪛘𪛙𪛚𪛛𪛜𪛝𰀀𰀁𰀂𰀃𰀄𰀅𰀆𰀇𰀈𰀉𰀊𰀋𰀌𰀍𰀎𰀏𰀐𰀑𰀒𰀓𰀔𰀕𰀖𰀗𰀘𰀙𰀚𰀛𰀜𰀝𰀞𰀟𰀠𰀡𰀢𰀣𰀤𰀥𰀦𰀧𰀨𰀩𰀪𰀫𰀬𰀭𰀮𰀯𰀰𰀱𰀲𰀳𰀴𰀵𰀶𰀷𰀸𰀹𰀺𰀻𰀼𰀽𰀾𰀿𰁀𰁁𰁂𰁃𰁄𰁅𰁆𰁇𰁈𰁉𰁊𰁋𰁌𰁍𰁎𰁏𰁐𰁑𰁒𰁓𰁔𰁕𰁖𰁗𰁘𰁙𰁚𰁛𰁜𰁝𰁞𰁟𰁠𰁡𰁢𰁣𰁤𰁥𰁦𰁧𰁨𰁩𰁪𰁫𰁬𰁭𰁮𰁯𰁰𰁱𰁲𰁳𰁴𰁵𰁶𰁷𰁸𰁹𰁺𰁻𰁼𰁽𰁾𰁿𰂀𰂁𰂂𰂃𰂄𰂅𰂆𰂇𰂈𰂉𰂊𰂋𰂌𰂍𰂎𰂏𰂐𰂑𰂒𰂓𰂔𰂕𰂖𰂗𰂘𰂙𰂚𰂛𰂜𰂝𰂞𰂟𰂠𰂡𰂢𰂣𰂤𰂥𰂦𰂧𰂨𰂩𰂪𰂫𰂬𰂭𰂮𰂯𰂰𰂱𰂲𰂳𰂴𰂵𰂶𰂷𰂸𰂹𰂺𰂻𰂼𰂽𰂾𰂿𰃀𰃁𰃂𰃃𰃄𰃅𰃆𰃇𰃈𰃉𰃊𰃋𰃌𰃍𰃎𰃏𰃐𰃑𰃒𰃓𰃔𰃕𰃖𰃗𰃘𰃙𰃚𰃛𰃜𰃝𰃞𰃟𰃠𰃡𰃢𰃣𰃤𰃥𰃦𰃧𰃨𰃩𰃪𰃫𰃬𰃭𰃮𰃯𰃰𰃱𰃲𰃳𰃴𰃵𰃶𰃷𰃸𰃹𰃺𰃻𰃼𰃽𰃾𰃿𰄀𰄁𰄂𰄃𰄄𰄅𰄆𰄇𰄈𰄉𰄊𰄋𰄌𰄍𰄎𰄏𰄐𰄑𰄒𰄓𰄔𰄕𰄖𰄗𰄘𰄙𰄚𰄛𰄜𰄝𰄞𰄟𰄠𰄡𰄢𰄣𰄤𰄥𰄦𰄧𰄨𰄩𰄪𰄫𰄬𰄭𰄮𰄯𰄰𰄱𰄲𰄳𰄴𰄵𰄶𰄷𰄸𰄹𰄺𰄻𰄼𰄽𰄾𰄿𰅀𰅁𰅂𰅃𰅄𰅅𰅆𰅇𰅈𰅉𰅊𰅋𰅌𰅍𰅎𰅏𰅐𰅑𰅒𰅓𰅔𰅕𰅖𰅗𰅘𰅙𰅚𰅛𰅜𰅝𰅞𰅟𰅠𰅡𰅢𰅣𰅤𰅥𰅦𰅧𰅨𰅩𰅪𰅫𰅬𰅭𰅮𰅯𰅰𰅱𰅲𰅳𰅴𰅵𰅶𰅷𰅸𰅹𰅺𰅻𰅼𰅽𰅾𰅿𰆀𰆁𰆂𰆃𰆄𰆅𰆆𰆇𰆈𰆉𰆊𰆋𰆌𰆍𰆎𰆏𰆐𰆑𰆒𰆓𰆔𰆕𰆖𰆗𰆘𰆙𰆚𰆛𰆜𰆝𰆞𰆟𰆠𰆡𰆢𰆣𰆤𰆥𰆦𰆧𰆨𰆩𰆪𰆫𰆬𰆭𰆮𰆯𰆰𰆱𰆲𰆳𰆴𰆵𰆶𰆷𰆸𰆹𰆺𰆻𰆼𰆽𰆾𰆿𰇀𰇁𰇂𰇃𰇄𰇅𰇆𰇇𰇈𰇉𰇊𰇋𰇌𰇍𰇎𰇏𰇐𰇑𰇒𰇓𰇔𰇕𰇖𰇗𰇘𰇙𰇚𰇛𰇜𰇝𰇞𰇟𰇠𰇡𰇢𰇣𰇤𰇥𰇦𰇧𰇨𰇩𰇪𰇫𰇬𰇭𰇮𰇯𰇰𰇱𰇲𰇳𰇴𰇵𰇶𰇷𰇸𰇹𰇺𰇻𰇼𰇽𰇾𰇿𰈀𰈁𰈂𰈃𰈄𰈅𰈆𰈇𰈈𰈉𰈊𰈋𰈌𰈍𰈎𰈏𰈐𰈑𰈒𰈓𰈔𰈕𰈖𰈗𰈘𰈙𰈚𰈛𰈜𰈝𰈞𰈟𰈠𰈡𰈢𰈣𰈤𰈥𰈦𰈧𰈨𰈩𰈪𰈫𰈬𰈭𰈮𰈯𰈰𰈱𰈲𰈳𰈴𰈵𰈶𰈷𰈸𰈹𰈺𰈻𰈼𰈽𰈾𰈿𰉀𰉁𰉂𰉃𰉄𰉅𰉆𰉇𰉈𰉉𰉊𰉋𰉌𰉍𰉎𰉏𰉐𰉑𰉒𰉓𰉔𰉕𰉖𰉗𰉘𰉙𰉚𰉛𰉜𰉝𰉞𰉟𰉠𰉡𰉢𰉣𰉤𰉥𰉦𰉧𰉨𰉩𰉪𰉫𰉬𰉭𰉮𰉯𰉰𰉱𰉲𰉳𰉴𰉵𰉶𰉷𰉸𰉹𰉺𰉻𰉼𰉽𰉾𰉿𰊀𰊁𰊂𰊃𰊄𰊅𰊆𰊇𰊈𰊉𰊊𰊋𰊌𰊍𰊎𰊏𰊐𰊑𰊒𰊓𰊔𰊕𰊖𰊗𰊘𰊙𰊚𰊛𰊜𰊝𰊞𰊟𰊠𰊡𰊢𰊣𰊤𰊥𰊦𰊧𰊨𰊩𰊪𰊫𰊬𰊭𰊮𰊯𰊰𰊱𰊲𰊳𰊴𰊵𰊶𰊷𰊸𰊹𰊺𰊻𰊼𰊽𰊾𰊿𰋀𰋁𰋂𰋃𰋄𰋅𰋆𰋇𰋈𰋉𰋊𰋋𰋌𰋍𰋎𰋏𰋐𰋑𰋒𰋓𰋔𰋕𰋖𰋗𰋘𰋙𰋚𰋛𰋜𰋝𰋞𰋟𰋠𰋡𰋢𰋣𰋤𰋥𰋦𰋧𰋨𰋩𰋪𰋫𰋬𰋭𰋮𰋯𰋰𰋱𰋲𰋳𰋴𰋵𰋶𰋷𰋸𰋹𰋺𰋻𰋼𰋽𰋾𰋿𰌀𰌁𰌂𰌃𰌄𰌅𰌆𰌇𰌈𰌉𰌊𰌋𰌌𰌍𰌎𰌏𰌐𰌑𰌒𰌓𰌔𰌕𰌖𰌗𰌘𰌙𰌚𰌛𰌜𰌝𰌞𰌟𰌠𰌡𰌢𰌣𰌤𰌥𰌦𰌧𰌨𰌩𰌪𰌫𰌬𰌭𰌮𰌯𰌰𰌱𰌲𰌳𰌴𰌵𰌶𰌷𰌸𰌹𰌺𰌻𰌼𰌽𰌾𰌿𰍀𰍁𰍂𰍃𰍄𰍅𰍆𰍇𰍈𰍉𰍊𰍋𰍌𰍍𰍎𰍏𰍐𰍑𰍒𰍓𰍔𰍕𰍖𰍗𰍘𰍙𰍚𰍛𰍜𰍝𰍞𰍟𰍠𰍡𰍢𰍣𰍤𰍥𰍦𰍧𰍨𰍩𰍪𰍫𰍬𰍭𰍮𰍯𰍰𰍱𰍲𰍳𰍴𰍵𰍶𰍷𰍸𰍹𰍺𰍻𰍼𰍽𰍾𰍿𰎀𰎁𰎂𰎃𰎄𰎅𰎆𰎇𰎈𰎉𰎊𰎋𰎌𰎍𰎎𰎏𰎐𰎑𰎒𰎓𰎔𰎕𰎖𰎗𰎘𰎙𰎚𰎛𰎜𰎝𰎞𰎟𰎠𰎡𰎢𰎣𰎤𰎥𰎦𰎧𰎨𰎩𰎪𰎫𰎬𰎭𰎮𰎯𰎰𰎱𰎲𰎳𰎴𰎵𰎶𰎷𰎸𰎹𰎺𰎻𰎼𰎽𰎾𰎿𰏀𰏁𰏂𰏃𰏄𰏅𰏆𰏇𰏈𰏉𰏊𰏋𰏌𰏍𰏎𰏏𰏐𰏑𰏒𰏓𰏔𰏕𰏖𰏗𰏘𰏙𰏚𰏛𰏜𰏝𰏞𰏟𰏠𰏡𰏢𰏣𰏤𰏥𰏦𰏧𰏨𰏩𰏪𰏫𰏬𰏭𰏮𰏯𰏰𰏱𰏲𰏳𰏴𰏵𰏶𰏷𰏸𰏹𰏺𰏻𰏼𰏽𰏾𰏿𰐀𰐁𰐂𰐃𰐄𰐅𰐆𰐇𰐈𰐉𰐊𰐋𰐌𰐍𰐎𰐏𰐐𰐑𰐒𰐓𰐔𰐕𰐖𰐗𰐘𰐙𰐚𰐛𰐜𰐝𰐞𰐟𰐠𰐡𰐢𰐣𰐤𰐥𰐦𰐧𰐨𰐩𰐪𰐫𰐬𰐭𰐮𰐯𰐰𰐱𰐲𰐳𰐴𰐵𰐶𰐷𰐸𰐹𰐺𰐻𰐼𰐽𰐾𰐿𰑀𰑁𰑂𰑃𰑄𰑅𰑆𰑇𰑈𰑉𰑊𰑋𰑌𰑍𰑎𰑏𰑐𰑑𰑒𰑓𰑔𰑕𰑖𰑗𰑘𰑙𰑚𰑛𰑜𰑝𰑞𰑟𰑠𰑡𰑢𰑣𰑤𰑥𰑦𰑧𰑨𰑩𰑪𰑫𰑬𰑭𰑮𰑯𰑰𰑱𰑲𰑳𰑴𰑵𰑶𰑷𰑸𰑹𰑺𰑻𰑼𰑽𰑾𰑿𰒀𰒁𰒂𰒃𰒄𰒅𰒆𰒇𰒈𰒉𰒊𰒋𰒌𰒍𰒎𰒏𰒐𰒑𰒒𰒓𰒔𰒕𰒖𰒗𰒘𰒙𰒚𰒛𰒜𰒝𰒞𰒟𰒠𰒡𰒢𰒣𰒤𰒥𰒦𰒧𰒨𰒩𰒪𰒫𰒬𰒭𰒮𰒯𰒰𰒱𰒲𰒳𰒴𰒵𰒶𰒷𰒸𰒹𰒺𰒻𰒼𰒽𰒾𰒿𰓀𰓁𰓂𰓃𰓄𰓅𰓆𰓇𰓈𰓉𰓊𰓋𰓌𰓍𰓎𰓏𰓐𰓑𰓒𰓓𰓔𰓕𰓖𰓗𰓘𰓙𰓚𰓛𰓜𰓝𰓞𰓟𰓠𰓡𰓢𰓣𰓤𰓥𰓦𰓧𰓨𰓩𰓪𰓫𰓬𰓭𰓮𰓯𰓰𰓱𰓲𰓳𰓴𰓵𰓶𰓷𰓸𰓹𰓺𰓻𰓼𰓽𰓾𰓿𰔀𰔁𰔂𰔃𰔄𰔅𰔆𰔇𰔈𰔉𰔊𰔋𰔌𰔍𰔎𰔏𰔐𰔑𰔒𰔓𰔔𰔕𰔖𰔗𰔘𰔙𰔚𰔛𰔜𰔝𰔞𰔟𰔠𰔡𰔢𰔣𰔤𰔥𰔦𰔧𰔨𰔩𰔪𰔫𰔬𰔭𰔮𰔯𰔰𰔱𰔲𰔳𰔴𰔵𰔶𰔷𰔸𰔹𰔺𰔻𰔼𰔽𰔾𰔿𰕀𰕁𰕂𰕃𰕄𰕅𰕆𰕇𰕈𰕉𰕊𰕋𰕌𰕍𰕎𰕏𰕐𰕑𰕒𰕓𰕔𰕕𰕖𰕗𰕘𰕙𰕚𰕛𰕜𰕝𰕞𰕟𰕠𰕡𰕢𰕣𰕤𰕥𰕦𰕧𰕨𰕩𰕪𰕫𰕬𰕭𰕮𰕯𰕰𰕱𰕲𰕳𰕴𰕵𰕶𰕷𰕸𰕹𰕺𰕻𰕼𰕽𰕾𰕿𰖀𰖁𰖂𰖃𰖄𰖅𰖆𰖇𰖈𰖉𰖊𰖋𰖌𰖍𰖎𰖏𰖐𰖑𰖒𰖓𰖔𰖕𰖖𰖗𰖘𰖙𰖚𰖛𰖜𰖝𰖞𰖟𰖠𰖡𰖢𰖣𰖤𰖥𰖦𰖧𰖨𰖩𰖪𰖫𰖬𰖭𰖮𰖯𰖰𰖱𰖲𰖳𰖴𰖵𰖶𰖷𰖸𰖹𰖺𰖻𰖼𰖽𰖾𰖿𰗀𰗁𰗂𰗃𰗄𰗅𰗆𰗇𰗈𰗉𰗊𰗋𰗌𰗍𰗎𰗏𰗐𰗑𰗒𰗓𰗔𰗕𰗖𰗗𰗘𰗙𰗚𰗛𰗜𰗝𰗞𰗟𰗠𰗡𰗢𰗣𰗤𰗥𰗦𰗧𰗨𰗩𰗪𰗫𰗬𰗭𰗮𰗯𰗰𰗱𰗲𰗳𰗴𰗵𰗶𰗷𰗸𰗹𰗺𰗻𰗼𰗽𰗾𰗿𰘀𰘁𰘂𰘃𰘄𰘅𰘆𰘇𰘈𰘉𰘊𰘋𰘌𰘍𰘎𰘏𰘐𰘑𰘒𰘓𰘔𰘕𰘖𰘗𰘘𰘙𰘚𰘛𰘜𰘝𰘞𰘟𰘠𰘡𰘢𰘣𰘤𰘥𰘦𰘧𰘨𰘩𰘪𰘫𰘬𰘭𰘮𰘯𰘰𰘱𰘲𰘳𰘴𰘵𰘶𰘷𰘸𰘹𰘺𰘻𰘼𰘽𰘾𰘿𰙀𰙁𰙂𰙃𰙄𰙅𰙆𰙇𰙈𰙉𰙊𰙋𰙌𰙍𰙎𰙏𰙐𰙑𰙒𰙓𰙔𰙕𰙖𰙗𰙘𰙙𰙚𰙛𰙜𰙝𰙞𰙟𰙠𰙡𰙢𰙣𰙤𰙥𰙦𰙧𰙨𰙩𰙪𰙫𰙬𰙭𰙮𰙯𰙰𰙱𰙲𰙳𰙴𰙵𰙶𰙷𰙸𰙹𰙺𰙻𰙼𰙽𰙾𰙿𰚀𰚁𰚂𰚃𰚄𰚅𰚆𰚇𰚈𰚉𰚊𰚋𰚌𰚍𰚎𰚏𰚐𰚑𰚒𰚓𰚔𰚕𰚖𰚗𰚘𰚙𰚚𰚛𰚜𰚝𰚞𰚟𰚠𰚡𰚢𰚣𰚤𰚥𰚦𰚧𰚨𰚩𰚪𰚫𰚬𰚭𰚮𰚯𰚰𰚱𰚲𰚳𰚴𰚵𰚶𰚷𰚸𰚹𰚺𰚻𰚼𰚽𰚾𰚿𰛀𰛁𰛂𰛃𰛄𰛅𰛆𰛇𰛈𰛉𰛊𰛋𰛌𰛍𰛎𰛏𰛐𰛑𰛒𰛓𰛔𰛕𰛖𰛗𰛘𰛙𰛚𰛛𰛜𰛝𰛞𰛟𰛠𰛡𰛢𰛣𰛤𰛥𰛦𰛧𰛨𰛩𰛪𰛫𰛬𰛭𰛮𰛯𰛰𰛱𰛲𰛳𰛴𰛵𰛶𰛷𰛸𰛹𰛺𰛻𰛼𰛽𰛾𰛿𰜀𰜁𰜂𰜃𰜄𰜅𰜆𰜇𰜈𰜉𰜊𰜋𰜌𰜍𰜎𰜏𰜐𰜑𰜒𰜓𰜔𰜕𰜖𰜗𰜘𰜙𰜚𰜛𰜜𰜝𰜞𰜟𰜠𰜡𰜢𰜣𰜤𰜥𰜦𰜧𰜨𰜩𰜪𰜫𰜬𰜭𰜮𰜯𰜰𰜱𰜲𰜳𰜴𰜵𰜶𰜷𰜸𰜹𰜺𰜻𰜼𰜽𰜾𰜿𰝀𰝁𰝂𰝃𰝄𰝅𰝆𰝇𰝈𰝉𰝊𰝋𰝌𰝍𰝎𰝏𰝐𰝑𰝒𰝓𰝔𰝕𰝖𰝗𰝘𰝙𰝚𰝛𰝜𰝝𰝞𰝟𰝠𰝡𰝢𰝣𰝤𰝥𰝦𰝧𰝨𰝩𰝪𰝫𰝬𰝭𰝮𰝯𰝰𰝱𰝲𰝳𰝴𰝵𰝶𰝷𰝸𰝹𰝺𰝻𰝼𰝽𰝾𰝿𰞀𰞁𰞂𰞃𰞄𰞅𰞆𰞇𰞈𰞉𰞊𰞋𰞌𰞍𰞎𰞏𰞐𰞑𰞒𰞓𰞔𰞕𰞖𰞗𰞘𰞙𰞚𰞛𰞜𰞝𰞞𰞟𰞠𰞡𰞢𰞣𰞤𰞥𰞦𰞧𰞨𰞩𰞪𰞫𰞬𰞭𰞮𰞯𰞰𰞱𰞲𰞳𰞴𰞵𰞶𰞷𰞸𰞹𰞺𰞻𰞼𰞽𰞾𰞿𰟀𰟁𰟂𰟃𰟄𰟅𰟆𰟇𰟈𰟉𰟊𰟋𰟌𰟍𰟎𰟏𰟐𰟑𰟒𰟓𰟔𰟕𰟖𰟗𰟘𰟙𰟚𰟛𰟜𰟝𰟞𰟟𰟠𰟡𰟢𰟣𰟤𰟥𰟦𰟧𰟨𰟩𰟪𰟫𰟬𰟭𰟮𰟯𰟰𰟱𰟲𰟳𰟴𰟵𰟶𰟷𰟸𰟹𰟺𰟻𰟼𰟽𰟾𰟿𰠀𰠁𰠂𰠃𰠄𰠅𰠆𰠇𰠈𰠉𰠊𰠋𰠌𰠍𰠎𰠏𰠐𰠑𰠒𰠓𰠔𰠕𰠖𰠗𰠘𰠙𰠚𰠛𰠜𰠝𰠞𰠟𰠠𰠡𰠢𰠣𰠤𰠥𰠦𰠧𰠨𰠩𰠪𰠫𰠬𰠭𰠮𰠯𰠰𰠱𰠲𰠳𰠴𰠵𰠶𰠷𰠸𰠹𰠺𰠻𰠼𰠽𰠾𰠿𰡀𰡁𰡂𰡃𰡄𰡅𰡆𰡇𰡈𰡉𰡊𰡋𰡌𰡍𰡎𰡏𰡐𰡑𰡒𰡓𰡔𰡕𰡖𰡗𰡘𰡙𰡚𰡛𰡜𰡝𰡞𰡟𰡠𰡡𰡢𰡣𰡤𰡥𰡦𰡧𰡨𰡩𰡪𰡫𰡬𰡭𰡮𰡯𰡰𰡱𰡲𰡳𰡴𰡵𰡶𰡷𰡸𰡹𰡺𰡻𰡼𰡽𰡾𰡿𰢀𰢁𰢂𰢃𰢄𰢅𰢆𰢇𰢈𰢉𰢊𰢋𰢌𰢍𰢎𰢏𰢐𰢑𰢒𰢓𰢔𰢕𰢖𰢗𰢘𰢙𰢚𰢛𰢜𰢝𰢞𰢟𰢠𰢡𰢢𰢣𰢤𰢥𰢦𰢧𰢨𰢩𰢪𰢫𰢬𰢭𰢮𰢯𰢰𰢱𰢲𰢳𰢴𰢵𰢶𰢷𰢸𰢹𰢺𰢻𰢼𰢽𰢾𰢿𰣀𰣁𰣂𰣃𰣄𰣅𰣆𰣇𰣈𰣉𰣊𰣋𰣌𰣍𰣎𰣏𰣐𰣑𰣒𰣓𰣔𰣕𰣖𰣗𰣘𰣙𰣚𰣛𰣜𰣝𰣞𰣟𰣠𰣡𰣢𰣣𰣤𰣥𰣦𰣧𰣨𰣩𰣪𰣫𰣬𰣭𰣮𰣯𰣰𰣱𰣲𰣳𰣴𰣵𰣶𰣷𰣸𰣹𰣺𰣻𰣼𰣽𰣾𰣿𰤀𰤁𰤂𰤃𰤄𰤅𰤆𰤇𰤈𰤉𰤊𰤋𰤌𰤍𰤎𰤏𰤐𰤑𰤒𰤓𰤔𰤕𰤖𰤗𰤘𰤙𰤚𰤛𰤜𰤝𰤞𰤟𰤠𰤡𰤢𰤣𰤤𰤥𰤦𰤧𰤨𰤩𰤪𰤫𰤬𰤭𰤮𰤯𰤰𰤱𰤲𰤳𰤴𰤵𰤶𰤷𰤸𰤹𰤺𰤻𰤼𰤽𰤾𰤿𰥀𰥁𰥂𰥃𰥄𰥅𰥆𰥇𰥈𰥉𰥊𰥋𰥌𰥍𰥎𰥏𰥐𰥑𰥒𰥓𰥔𰥕𰥖𰥗𰥘𰥙𰥚𰥛𰥜𰥝𰥞𰥟𰥠𰥡𰥢𰥣𰥤𰥥𰥦𰥧𰥨𰥩𰥪𰥫𰥬𰥭𰥮𰥯𰥰𰥱𰥲𰥳𰥴𰥵𰥶𰥷𰥸𰥹𰥺𰥻𰥼𰥽𰥾𰥿𰦀𰦁𰦂𰦃𰦄𰦅𰦆𰦇𰦈𰦉𰦊𰦋𰦌𰦍𰦎𰦏𰦐𰦑𰦒𰦓𰦔𰦕𰦖𰦗𰦘𰦙𰦚𰦛𰦜𰦝𰦞𰦟𰦠𰦡𰦢𰦣𰦤𰦥𰦦𰦧𰦨𰦩𰦪𰦫𰦬𰦭𰦮𰦯𰦰𰦱𰦲𰦳𰦴𰦵𰦶𰦷𰦸𰦹𰦺𰦻𰦼𰦽𰦾𰦿𰧀𰧁𰧂𰧃𰧄𰧅𰧆𰧇𰧈𰧉𰧊𰧋𰧌𰧍𰧎𰧏𰧐𰧑𰧒𰧓𰧔𰧕𰧖𰧗𰧘𰧙𰧚𰧛𰧜𰧝𰧞𰧟𰧠𰧡𰧢𰧣𰧤𰧥𰧦𰧧𰧨𰧩𰧪𰧫𰧬𰧭𰧮𰧯𰧰𰧱𰧲𰧳𰧴𰧵𰧶𰧷𰧸𰧹𰧺𰧻𰧼𰧽𰧾𰧿𰨀𰨁𰨂𰨃𰨄𰨅𰨆𰨇𰨈𰨉𰨊𰨋𰨌𰨍𰨎𰨏𰨐𰨑𰨒𰨓𰨔𰨕𰨖𰨗𰨘𰨙𰨚𰨛𰨜𰨝𰨞𰨟𰨠𰨡𰨢𰨣𰨤𰨥𰨦𰨧𰨨𰨩𰨪𰨫𰨬𰨭𰨮𰨯𰨰𰨱𰨲𰨳𰨴𰨵𰨶𰨷𰨸𰨹𰨺𰨻𰨼𰨽𰨾𰨿𰩀𰩁𰩂𰩃𰩄𰩅𰩆𰩇𰩈𰩉𰩊𰩋𰩌𰩍𰩎𰩏𰩐𰩑𰩒𰩓𰩔𰩕𰩖𰩗𰩘𰩙𰩚𰩛𰩜𰩝𰩞𰩟𰩠𰩡𰩢𰩣𰩤𰩥𰩦𰩧𰩨𰩩𰩪𰩫𰩬𰩭𰩮𰩯𰩰𰩱𰩲𰩳𰩴𰩵𰩶𰩷𰩸𰩹𰩺𰩻𰩼𰩽𰩾𰩿𰪀𰪁𰪂𰪃𰪄𰪅𰪆𰪇𰪈𰪉𰪊𰪋𰪌𰪍𰪎𰪏𰪐𰪑𰪒𰪓𰪔𰪕𰪖𰪗𰪘𰪙𰪚𰪛𰪜𰪝𰪞𰪟𰪠𰪡𰪢𰪣𰪤𰪥𰪦𰪧𰪨𰪩𰪪𰪫𰪬𰪭𰪮𰪯𰪰𰪱𰪲𰪳𰪴𰪵𰪶𰪷𰪸𰪹𰪺𰪻𰪼𰪽𰪾𰪿𰫀𰫁𰫂𰫃𰫄𰫅𰫆𰫇𰫈𰫉𰫊𰫋𰫌𰫍𰫎𰫏𰫐𰫑𰫒𰫓𰫔𰫕𰫖𰫗𰫘𰫙𰫚𰫛𰫜𰫝𰫞𰫟𰫠𰫡𰫢𰫣𰫤𰫥𰫦𰫧𰫨𰫩𰫪𰫫𰫬𰫭𰫮𰫯𰫰𰫱𰫲𰫳𰫴𰫵𰫶𰫷𰫸𰫹𰫺𰫻𰫼𰫽𰫾𰫿𰬀𰬁𰬂𰬃𰬄𰬅𰬆𰬇𰬈𰬉𰬊𰬋𰬌𰬍𰬎𰬏𰬐𰬑𰬒𰬓𰬔𰬕𰬖𰬗𰬘𰬙𰬚𰬛𰬜𰬝𰬞𰬟𰬠𰬡𰬢𰬣𰬤𰬥𰬦𰬧𰬨𰬩𰬪𰬫𰬬𰬭𰬮𰬯𰬰𰬱𰬲𰬳𰬴𰬵𰬶𰬷𰬸𰬹𰬺𰬻𰬼𰬽𰬾𰬿𰭀𰭁𰭂𰭃𰭄𰭅𰭆𰭇𰭈𰭉𰭊𰭋𰭌𰭍𰭎𰭏𰭐𰭑𰭒𰭓𰭔𰭕𰭖𰭗𰭘𰭙𰭚𰭛𰭜𰭝𰭞𰭟𰭠𰭡𰭢𰭣𰭤𰭥𰭦𰭧𰭨𰭩𰭪𰭫𰭬𰭭𰭮𰭯𰭰𰭱𰭲𰭳𰭴𰭵𰭶𰭷𰭸𰭹𰭺𰭻𰭼𰭽𰭾𰭿𰮀𰮁𰮂𰮃𰮄𰮅𰮆𰮇𰮈𰮉𰮊𰮋𰮌𰮍𰮎𰮏𰮐𰮑𰮒𰮓𰮔𰮕𰮖𰮗𰮘𰮙𰮚𰮛𰮜𰮝𰮞𰮟𰮠𰮡𰮢𰮣𰮤𰮥𰮦𰮧𰮨𰮩𰮪𰮫𰮬𰮭𰮮𰮯𰮰𰮱𰮲𰮳𰮴𰮵𰮶𰮷𰮸𰮹𰮺𰮻𰮼𰮽𰮾𰮿𰯀𰯁𰯂𰯃𰯄𰯅𰯆𰯇𰯈𰯉𰯊𰯋𰯌𰯍𰯎𰯏𰯐𰯑𰯒𰯓𰯔𰯕𰯖𰯗𰯘𰯙𰯚𰯛𰯜𰯝𰯞𰯟𰯠𰯡𰯢𰯣𰯤𰯥𰯦𰯧𰯨𰯩𰯪𰯫𰯬𰯭𰯮𰯯𰯰𰯱𰯲𰯳𰯴𰯵𰯶𰯷𰯸𰯹𰯺𰯻𰯼𰯽𰯾𰯿𰰀𰰁𰰂𰰃𰰄𰰅𰰆𰰇𰰈𰰉𰰊𰰋𰰌𰰍𰰎𰰏𰰐𰰑𰰒𰰓𰰔𰰕𰰖𰰗𰰘𰰙𰰚𰰛𰰜𰰝𰰞𰰟𰰠𰰡𰰢𰰣𰰤𰰥𰰦𰰧𰰨𰰩𰰪𰰫𰰬𰰭𰰮𰰯𰰰𰰱𰰲𰰳𰰴𰰵𰰶𰰷𰰸𰰹𰰺𰰻𰰼𰰽𰰾𰰿𰱀𰱁𰱂𰱃𰱄𰱅𰱆𰱇𰱈𰱉𰱊𰱋𰱌𰱍𰱎𰱏𰱐𰱑𰱒𰱓𰱔𰱕𰱖𰱗𰱘𰱙𰱚𰱛𰱜𰱝𰱞𰱟𰱠𰱡𰱢𰱣𰱤𰱥𰱦𰱧𰱨𰱩𰱪𰱫𰱬𰱭𰱮𰱯𰱰𰱱𰱲𰱳𰱴𰱵𰱶𰱷𰱸𰱹𰱺𰱻𰱼𰱽𰱾𰱿𰲀𰲁𰲂𰲃𰲄𰲅𰲆𰲇𰲈𰲉𰲊𰲋𰲌𰲍𰲎𰲏𰲐𰲑𰲒𰲓𰲔𰲕𰲖𰲗𰲘𰲙𰲚𰲛𰲜𰲝𰲞𰲟𰲠𰲡𰲢𰲣𰲤𰲥𰲦𰲧𰲨𰲩𰲪𰲫𰲬𰲭𰲮𰲯𰲰𰲱𰲲𰲳𰲴𰲵𰲶𰲷𰲸𰲹𰲺𰲻𰲼𰲽𰲾𰲿𰳀𰳁𰳂𰳃𰳄𰳅𰳆𰳇𰳈𰳉𰳊𰳋𰳌𰳍𰳎𰳏𰳐𰳑𰳒𰳓𰳔𰳕𰳖𰳗𰳘𰳙𰳚𰳛𰳜𰳝𰳞𰳟𰳠𰳡𰳢𰳣𰳤𰳥𰳦𰳧𰳨𰳩𰳪𰳫𰳬𰳭𰳮𰳯𰳰𰳱𰳲𰳳𰳴𰳵𰳶𰳷𰳸𰳹𰳺𰳻𰳼𰳽𰳾𰳿𰴀𰴁𰴂𰴃𰴄𰴅𰴆𰴇𰴈𰴉𰴊𰴋𰴌𰴍𰴎𰴏𰴐𰴑𰴒𰴓𰴔𰴕𰴖𰴗𰴘𰴙𰴚𰴛𰴜𰴝𰴞𰴟𰴠𰴡𰴢𰴣𰴤𰴥𰴦𰴧𰴨𰴩𰴪𰴫𰴬𰴭𰴮𰴯𰴰𰴱𰴲𰴳𰴴𰴵𰴶𰴷𰴸𰴹𰴺𰴻𰴼𰴽𰴾𰴿𰵀𰵁𰵂𰵃𰵄𰵅𰵆𰵇𰵈𰵉𰵊𰵋𰵌𰵍𰵎𰵏𰵐𰵑𰵒𰵓𰵔𰵕𰵖𰵗𰵘𰵙𰵚𰵛𰵜𰵝𰵞𰵟𰵠𰵡𰵢𰵣𰵤𰵥𰵦𰵧𰵨𰵩𰵪𰵫𰵬𰵭𰵮𰵯𰵰𰵱𰵲𰵳𰵴𰵵𰵶𰵷𰵸𰵹𰵺𰵻𰵼𰵽𰵾𰵿𰶀𰶁𰶂𰶃𰶄𰶅𰶆𰶇𰶈𰶉𰶊𰶋𰶌𰶍𰶎𰶏𰶐𰶑𰶒𰶓𰶔𰶕𰶖𰶗𰶘𰶙𰶚𰶛𰶜𰶝𰶞𰶟𰶠𰶡𰶢𰶣𰶤𰶥𰶦𰶧𰶨𰶩𰶪𰶫𰶬𰶭𰶮𰶯𰶰𰶱𰶲𰶳𰶴𰶵𰶶𰶷𰶸𰶹𰶺𰶻𰶼𰶽𰶾𰶿𰷀𰷁𰷂𰷃𰷄𰷅𰷆𰷇𰷈𰷉𰷊𰷋𰷌𰷍𰷎𰷏𰷐𰷑𰷒𰷓𰷔𰷕𰷖𰷗𰷘𰷙𰷚𰷛𰷜𰷝𰷞𰷟𰷠𰷡𰷢𰷣𰷤𰷥𰷦𰷧𰷨𰷩𰷪𰷫𰷬𰷭𰷮𰷯𰷰𰷱𰷲𰷳𰷴𰷵𰷶𰷷𰷸𰷹𰷺𰷻𰷼𰷽𰷾𰷿𰸀𰸁𰸂𰸃𰸄𰸅𰸆𰸇𰸈𰸉𰸊𰸋𰸌𰸍𰸎𰸏𰸐𰸑𰸒𰸓𰸔𰸕𰸖𰸗𰸘𰸙𰸚𰸛𰸜𰸝𰸞𰸟𰸠𰸡𰸢𰸣𰸤𰸥𰸦𰸧𰸨𰸩𰸪𰸫𰸬𰸭𰸮𰸯𰸰𰸱𰸲𰸳𰸴𰸵𰸶𰸷𰸸𰸹𰸺𰸻𰸼𰸽𰸾𰸿𰹀𰹁𰹂𰹃𰹄𰹅𰹆𰹇𰹈𰹉𰹊𰹋𰹌𰹍𰹎𰹏𰹐𰹑𰹒𰹓𰹔𰹕𰹖𰹗𰹘𰹙𰹚𰹛𰹜𰹝𰹞𰹟𰹠𰹡𰹢𰹣𰹤𰹥𰹦𰹧𰹨𰹩𰹪𰹫𰹬𰹭𰹮𰹯𰹰𰹱𰹲𰹳𰹴𰹵𰹶𰹷𰹸𰹹𰹺𰹻𰹼𰹽𰹾𰹿𰺀𰺁𰺂𰺃𰺄𰺅𰺆𰺇𰺈𰺉𰺊𰺋𰺌𰺍𰺎𰺏𰺐𰺑𰺒𰺓𰺔𰺕𰺖𰺗𰺘𰺙𰺚𰺛𰺜𰺝𰺞𰺟𰺠𰺡𰺢𰺣𰺤𰺥𰺦𰺧𰺨𰺩𰺪𰺫𰺬𰺭𰺮𰺯𰺰𰺱𰺲𰺳𰺴𰺵𰺶𰺷𰺸𰺹𰺺𰺻𰺼𰺽𰺾𰺿𰻀𰻁𰻂𰻃𰻄𰻅𰻆𰻇𰻈𰻉𰻊𰻋𰻌𰻍𰻎𰻏𰻐𰻑𰻒𰻓𰻔𰻕𰻖𰻗𰻘𰻙𰻚𰻛𰻜𰻝𰻞𰻟𰻠𰻡𰻢𰻣𰻤𰻥𰻦𰻧𰻨𰻩𰻪𰻫𰻬𰻭𰻮𰻯𰻰𰻱𰻲𰻳𰻴𰻵𰻶𰻷𰻸𰻹𰻺𰻻𰻼𰻽𰻾𰻿𰼀𰼁𰼂𰼃𰼄𰼅𰼆𰼇𰼈𰼉𰼊𰼋𰼌𰼍𰼎𰼏𰼐𰼑𰼒𰼓𰼔𰼕𰼖𰼗𰼘𰼙𰼚𰼛𰼜𰼝𰼞𰼟𰼠𰼡𰼢𰼣𰼤𰼥𰼦𰼧𰼨𰼩𰼪𰼫𰼬𰼭𰼮𰼯𰼰𰼱𰼲𰼳𰼴𰼵𰼶𰼷𰼸𰼹𰼺𰼻𰼼𰼽𰼾𰼿𰽀𰽁𰽂𰽃𰽄𰽅𰽆𰽇𰽈𰽉𰽊𰽋𰽌𰽍𰽎𰽏𰽐𰽑𰽒𰽓𰽔𰽕𰽖𰽗𰽘𰽙𰽚𰽛𰽜𰽝𰽞𰽟𰽠𰽡𰽢𰽣𰽤𰽥𰽦𰽧𰽨𰽩𰽪𰽫𰽬𰽭𰽮𰽯𰽰𰽱𰽲𰽳𰽴𰽵𰽶𰽷𰽸𰽹𰽺𰽻𰽼𰽽𰽾𰽿𰾀𰾁𰾂𰾃𰾄𰾅𰾆𰾇𰾈𰾉𰾊𰾋𰾌𰾍𰾎𰾏𰾐𰾑𰾒𰾓𰾔𰾕𰾖𰾗𰾘𰾙𰾚𰾛𰾜𰾝𰾞𰾟𰾠𰾡𰾢𰾣𰾤𰾥𰾦𰾧𰾨𰾩𰾪𰾫𰾬𰾭𰾮𰾯𰾰𰾱𰾲𰾳𰾴𰾵𰾶𰾷𰾸𰾹𰾺𰾻𰾼𰾽𰾾𰾿𰿀𰿁𰿂𰿃𰿄𰿅𰿆𰿇𰿈𰿉𰿊𰿋𰿌𰿍𰿎𰿏𰿐𰿑𰿒𰿓𰿔𰿕𰿖𰿗𰿘𰿙𰿚𰿛𰿜𰿝𰿞𰿟𰿠𰿡𰿢𰿣𰿤𰿥𰿦𰿧𰿨𰿩𰿪𰿫𰿬𰿭𰿮𰿯𰿰𰿱𰿲𰿳𰿴𰿵𰿶𰿷𰿸𰿹𰿺𰿻𰿼𰿽𰿾𰿿𱀀𱀁𱀂𱀃𱀄𱀅𱀆𱀇𱀈𱀉𱀊𱀋𱀌𱀍𱀎𱀏𱀐𱀑𱀒𱀓𱀔𱀕𱀖𱀗𱀘𱀙𱀚𱀛𱀜𱀝𱀞𱀟𱀠𱀡𱀢𱀣𱀤𱀥𱀦𱀧𱀨𱀩𱀪𱀫𱀬𱀭𱀮𱀯𱀰𱀱𱀲𱀳𱀴𱀵𱀶𱀷𱀸𱀹𱀺𱀻𱀼𱀽𱀾𱀿𱁀𱁁𱁂𱁃𱁄𱁅𱁆𱁇𱁈𱁉𱁊𱁋𱁌𱁍𱁎𱁏𱁐𱁑𱁒𱁓𱁔𱁕𱁖𱁗𱁘𱁙𱁚𱁛𱁜𱁝𱁞𱁟𱁠𱁡𱁢𱁣𱁤𱁥𱁦𱁧𱁨𱁩𱁪𱁫𱁬𱁭𱁮𱁯𱁰𱁱𱁲𱁳𱁴𱁵𱁶𱁷𱁸𱁹𱁺𱁻𱁼𱁽𱁾𱁿𱂀𱂁𱂂𱂃𱂄𱂅𱂆𱂇𱂈𱂉𱂊𱂋𱂌𱂍𱂎𱂏𱂐𱂑𱂒𱂓𱂔𱂕𱂖𱂗𱂘𱂙𱂚𱂛𱂜𱂝𱂞𱂟𱂠𱂡𱂢𱂣𱂤𱂥𱂦𱂧𱂨𱂩𱂪𱂫𱂬𱂭𱂮𱂯𱂰𱂱𱂲𱂳𱂴𱂵𱂶𱂷𱂸𱂹𱂺𱂻𱂼𱂽𱂾𱂿𱃀𱃁𱃂𱃃𱃄𱃅𱃆𱃇𱃈𱃉𱃊𱃋𱃌𱃍𱃎𱃏𱃐𱃑𱃒𱃓𱃔𱃕𱃖𱃗𱃘𱃙𱃚𱃛𱃜𱃝𱃞𱃟𱃠𱃡𱃢𱃣𱃤𱃥𱃦𱃧𱃨𱃩𱃪𱃫𱃬𱃭𱃮𱃯𱃰𱃱𱃲𱃳𱃴𱃵𱃶𱃷𱃸𱃹𱃺𱃻𱃼𱃽𱃾𱃿𱄀𱄁𱄂𱄃𱄄𱄅𱄆𱄇𱄈𱄉𱄊𱄋𱄌𱄍𱄎𱄏𱄐𱄑𱄒𱄓𱄔𱄕𱄖𱄗𱄘𱄙𱄚𱄛𱄜𱄝𱄞𱄟𱄠𱄡𱄢𱄣𱄤𱄥𱄦𱄧𱄨𱄩𱄪𱄫𱄬𱄭𱄮𱄯𱄰𱄱𱄲𱄳𱄴𱄵𱄶𱄷𱄸𱄹𱄺𱄻𱄼𱄽𱄾𱄿𱅀𱅁𱅂𱅃𱅄𱅅𱅆𱅇𱅈𱅉𱅊𱅋𱅌𱅍𱅎𱅏𱅐𱅑𱅒𱅓𱅔𱅕𱅖𱅗𱅘𱅙𱅚𱅛𱅜𱅝𱅞𱅟𱅠𱅡𱅢𱅣𱅤𱅥𱅦𱅧𱅨𱅩𱅪𱅫𱅬𱅭𱅮𱅯𱅰𱅱𱅲𱅳𱅴𱅵𱅶𱅷𱅸𱅹𱅺𱅻𱅼𱅽𱅾𱅿𱆀𱆁𱆂𱆃𱆄𱆅𱆆𱆇𱆈𱆉𱆊𱆋𱆌𱆍𱆎𱆏𱆐𱆑𱆒𱆓𱆔𱆕𱆖𱆗𱆘𱆙𱆚𱆛𱆜𱆝𱆞𱆟𱆠𱆡𱆢𱆣𱆤𱆥𱆦𱆧𱆨𱆩𱆪𱆫𱆬𱆭𱆮𱆯𱆰𱆱𱆲𱆳𱆴𱆵𱆶𱆷𱆸𱆹𱆺𱆻𱆼𱆽𱆾𱆿𱇀𱇁𱇂𱇃𱇄𱇅𱇆𱇇𱇈𱇉𱇊𱇋𱇌𱇍𱇎𱇏𱇐𱇑𱇒𱇓𱇔𱇕𱇖𱇗𱇘𱇙𱇚𱇛𱇜𱇝𱇞𱇟𱇠𱇡𱇢𱇣𱇤𱇥𱇦𱇧𱇨𱇩𱇪𱇫𱇬𱇭𱇮𱇯𱇰𱇱𱇲𱇳𱇴𱇵𱇶𱇷𱇸𱇹𱇺𱇻𱇼𱇽𱇾𱇿𱈀𱈁𱈂𱈃𱈄𱈅𱈆𱈇𱈈𱈉𱈊𱈋𱈌𱈍𱈎𱈏𱈐𱈑𱈒𱈓𱈔𱈕𱈖𱈗𱈘𱈙𱈚𱈛𱈜𱈝𱈞𱈟𱈠𱈡𱈢𱈣𱈤𱈥𱈦𱈧𱈨𱈩𱈪𱈫𱈬𱈭𱈮𱈯𱈰𱈱𱈲𱈳𱈴𱈵𱈶𱈷𱈸𱈹𱈺𱈻𱈼𱈽𱈾𱈿𱉀𱉁𱉂𱉃𱉄𱉅𱉆𱉇𱉈𱉉𱉊𱉋𱉌𱉍𱉎𱉏𱉐𱉑𱉒𱉓𱉔𱉕𱉖𱉗𱉘𱉙𱉚𱉛𱉜𱉝𱉞𱉟𱉠𱉡𱉢𱉣𱉤𱉥𱉦𱉧𱉨𱉩𱉪𱉫𱉬𱉭𱉮𱉯𱉰𱉱𱉲𱉳𱉴𱉵𱉶𱉷𱉸𱉹𱉺𱉻𱉼𱉽𱉾𱉿𱊀𱊁𱊂𱊃𱊄𱊅𱊆𱊇𱊈𱊉𱊊𱊋𱊌𱊍𱊎𱊏𱊐𱊑𱊒𱊓𱊔𱊕𱊖𱊗𱊘𱊙𱊚𱊛𱊜𱊝𱊞𱊟𱊠𱊡𱊢𱊣𱊤𱊥𱊦𱊧𱊨𱊩𱊪𱊫𱊬𱊭𱊮𱊯𱊰𱊱𱊲𱊳𱊴𱊵𱊶𱊷𱊸𱊹𱊺𱊻𱊼𱊽𱊾𱊿𱋀𱋁𱋂𱋃𱋄𱋅𱋆𱋇𱋈𱋉𱋊𱋋𱋌𱋍𱋎𱋏𱋐𱋑𱋒𱋓𱋔𱋕𱋖𱋗𱋘𱋙𱋚𱋛𱋜𱋝𱋞𱋟𱋠𱋡𱋢𱋣𱋤𱋥𱋦𱋧𱋨𱋩𱋪𱋫𱋬𱋭𱋮𱋯𱋰𱋱𱋲𱋳𱋴𱋵𱋶𱋷𱋸𱋹𱋺𱋻𱋼𱋽𱋾𱋿𱌀𱌁𱌂𱌃𱌄𱌅𱌆𱌇𱌈𱌉𱌊𱌋𱌌𱌍𱌎𱌏𱌐𱌑𱌒𱌓𱌔𱌕𱌖𱌗𱌘𱌙𱌚𱌛𱌜𱌝𱌞𱌟𱌠𱌡𱌢𱌣𱌤𱌥𱌦𱌧𱌨𱌩𱌪𱌫𱌬𱌭𱌮𱌯𱌰𱌱𱌲𱌳𱌴𱌵𱌶𱌷𱌸𱌹𱌺𱌻𱌼𱌽𱌾𱌿𱍀𱍁𱍂𱍃𱍄𱍅𱍆𱍇𱍈𱍉𱍊;

reportCompare(0, 0);
